import { defineComponent as _, ref as h, watch as m, openBlock as V, createElementBlock as b } from "vue";
import { EditorState as g, StateEffect as D } from "@codemirror/state";
import { EditorView as r } from "@codemirror/view";
import { jsonSchema as R, updateSchema as j } from "codemirror-json-schema";
import { commonExtensions as k } from "./extensions.js";
import { getRandomInt as z, formatJson as B, cleanedMapStr as x } from "./utils.js";
const C = ["id"], L = /* @__PURE__ */ _({
  __name: "Editor",
  props: {
    modelValue: {},
    schema: {},
    height: { default: "300px" },
    tabSize: { default: 4 },
    extensions: {},
    change: {}
  },
  emits: ["update:modelValue"],
  setup(S, { emit: v }) {
    const e = S, t = h(null), d = h(`json-schema-editor-${z(1e3)}`), E = v;
    return m(
      () => [e.schema, e.height, e.tabSize, e.extensions],
      ([o, s, c, i]) => {
        const l = [
          k,
          g.tabSize.of(c),
          r.theme({
            "&": {
              height: s
            }
          }),
          r.domEventHandlers({
            paste(a, n) {
              const f = a.clipboardData;
              if (!f)
                return;
              const u = f.getData("text/plain"), p = B(u, c);
              p !== u && (a.preventDefault(), n.dispatch({
                changes: {
                  from: n.state.selection.main.from,
                  to: n.state.selection.main.to,
                  insert: p
                }
              }));
            }
          }),
          R(o),
          r.updateListener.of((a) => {
            if (a.docChanged) {
              const n = a.state.doc.toString();
              E("update:modelValue", n), e.change && e.change(n);
            }
          }),
          i || []
        ];
        if (t.value)
          t.value.dispatch({
            effects: D.reconfigure.of(l)
          });
        else {
          const a = g.create({
            doc: e.modelValue,
            extensions: l
          });
          t.value = new r({
            state: a,
            parent: document.querySelector(`#${d.value}`)
          });
        }
      }
    ), m(
      () => e.modelValue,
      (o) => {
        var s, c, i;
        x(o) !== x((s = t.value) == null ? void 0 : s.state.doc.toString()) && ((i = t.value) == null || i.dispatch({
          changes: { from: 0, to: (c = t.value) == null ? void 0 : c.state.doc.length, insert: o }
        }));
      }
    ), m(
      () => e.schema,
      (o) => {
        t.value && j(t.value, o);
      }
    ), (o, s) => (V(), b("div", { id: d.value }, null, 8, C));
  }
});
export {
  L as default
};
